<?php
define("_GOOGLECHART_URL","http://sitemanpro.com/");
define("_GOOGLECHART_CACHE",false);
class GoogleChart{
        const BASE = 'http://chart.apis.google.com/chart?';
        protected $types = array(
                'pie' => 'p',
                'pie3d' => 'p3',
                'line' => 'lc',
                'sparkline' => 'ls',
                'bar-horizontal' => 'bhg',
                'bar-vertical' => 'bvg',
                'bhs' => 'bhs',
                'bvs' => 'bvs',
                'lc' => 'lc'
        );
        protected $type;
        protected $title;
        protected $data = array();
        protected $size = array();
        protected $color = array();
        protected $fill = array();
        protected $axisXY = false;
        protected $labelsXY = array();
        protected $legend;
        protected $useLegend = true;
        protected $background = 'a,s,ffffff';
        protected $query = array();
        public $debug = array();
        public function __toString(){
                return $this->display();
        }
        protected function display(){
                $this->query = array(
                        'cht'	 => $this->types[strtolower($this->type)],					// Type
                        'chtt'	 => $this->title,											// Title
                        'chd' => 't:'.$this->data['values'],								// Data
                        'chl'   => $this->data['names'],									// Data labels
                        //'chdl' => ( ($this->useLegend) && (is_array($this->legend)) ) ? implode('|',$this->legend) : null, // Data legend
                        'chdl' => ( (is_array($this->legend)) ) ? implode('|',$this->legend) : null, // Data legend
                        'chs'   => $this->size[0].'x'.$this->size[1],						// Size
                        'chco'   => preg_replace( '/[#]+/', '', implode(',',$this->color)), // Color ( Remove # from string )
                        'chm'   => preg_replace( '/[#]+/', '', implode('|',$this->fill)),   // Fill ( Remove # from string )
                        'chxt' => ( $this->axisXY == true) ? 'x,y' : null,				// X & Y axis labels
                        'chf' => preg_replace( '/[#]+/', '', $this->background),			// Background color ( Remove # from string )
                        'chxl'  =>  $this->labelsXY,
                        'chm'   => 'N*cUSD1*k,333333,0,-1,10',
                        'chbh'  => '50,10'
                        //'chxr'  =>  'chxr=0,0,125,10',
                        //'chd'   =>  'e:Bk',
                );
                //echo http_build_query($this->query) . "<br>";
                return $this->img(GoogleChart::BASE.http_build_query($this->query),$this->title);
        }
        public function setChartAttrs( $attrs ){
                $this->debug[] = $attrs;
                foreach( $attrs as $key => $value ){
                        $this->{"set$key"}($value);
                }
        }
        protected function setType( $type ){
                $this->type = $type;
        }
        protected function setTitle( $title ){
                $this->title = $title;
        }
        protected function setData( $data ){
                unset( $this->data );
                if( is_array(reset($data)) ){
                        foreach( $data as $key => $value ){
                                $this->data['values'][] = implode( ',', $value );
                                $this->data['names'] = implode( '|', array_keys( $value ) );
                        }
                        $this->data['values'] = implode('|', $this->data['values']);
                        $this->legend = array_keys( $data );
                }else{
                        $this->data['values'] = implode( ',', $data );
                        $this->data['names'] = implode( '|', array_keys( $data ) );
                }
        }
        protected function setLegend( $legend ){
                //$this->useLegend = $legend;
                $this->legend = $legend;
        }
        protected function setSize( $width, $height = null ){
                if(is_array( $width ) ){
                        $this->size = $width;
                }else{
                        $this->size[] = $width;
                        $this->size[] = $height;
                }
        }
        protected function setColor( $color ){
                $this->color = $color;
        }
        protected function setAxisXY( $flag ){
                $this->axisXY = $flag;
        }
        protected function setLabelsXY( $labels ){
                $this->labelsXY = $labels;
        }

        protected function setFill( $fill ){
                if( count( $fill ) < 4 ){
                        $count = count( $fill );
                        for( $i = 0; $i < $count; ++$i )
                                $fill[$i] = 'b,'.$fill[$i].','.$i.','.($i+1).',0';
                }
                $this->fill = $fill;
        }
        protected function setBackground( $background ){
                $this->background = 'bg,s,'.$background;
        }
        protected function img( $url, $alt = null ){
                if(_GOOGLECHART_CACHE){
                        $url = _GOOGLECHART_URL."/googlecharts/cacher.php?stream=".base64_encode($url);
                }else{
                        $url = $url;
                }
                return sprintf('<img src="%s" alt="%s" style="width:%spx;height:%spx;" />', $url, $alt, $this->size[0], $this->size[1]);
        }
}
?>