<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Dashboard extends Controller {

	function __construct() {
		parent::Controller();
		$this->load->model($this->config->item('dashboard_model'));
                //$this->load->library('Simplepie');
  	}

	//---------------------------------------------------------------
	
	/**
	 * Function: index
	 * Description: Shows the dashboard page
	 * ##############################################################
	 * Written: 03/06/2011
	 * Author: Deep Arora
	 * --------------------------------------------------------------
	 * Update Log:
	 * --------------------------------------------------------------	 
	 * ##############################################################	 
	 * @access public
	 * @return void
	 */	
	function index($year = '')
	{
            $quick_guides = ""; $forum_feed = ""; $admin_feed = "";
            
            if(!$year)
                $year = date("Y");
            
            //<editor-fold desc="CHECK USER PERMISSION">
            smp_check_permission($this->config->item('perm_view'));
            //</editor-fold>

            //<editor-fold desc="SET PAGE META">
            smp_set_page_meta('global', 'dashboard', '');
            //</editor-fold>

            $this->load->library('googlechart');
            $data_products = array(
                'IE7' => 22,
                'IE6' => 30.7,
                'IE5' => 1.7,
                'Firefox' => 36.5,
                'Mozilla' => 1.1,
                'Safari' => 2,
                'Opera' => 1.4,
            );

            // Set graph colors
            $color = array('#AFD8F8','#F6BD0F','#8BBA00','#FF8E46','#008E8E');

            $chart_top_products = new GoogleChart();

            $chart_top_products->setChartAttrs( array(
                'type' => 'pie',
                'title' => 'Top 10 Products in 2011',
                'data' => $data_products,
                'size' => array( 400, 300 ),
                'color' => $color
                ));

            //$chart_top_products = $this->googlechart;
            

            $data_sales = $this->Dashboard_model->monthly_sales($year);

            //$where_condition = "YEAR(transaction_date) = '$year'";
            //$sales_max = smp_lookup('MAX(transaction_amount)', 'global_transactions', $where_condition);
            //echo intval($sales_max/5);

            //$labelsY = "0|" . intval($sales_max/2.5) . "|" . intval($sales_max/1.66) . "|" . intval($sales_max/1.25) . "|" . intval($sales_max/1);

            $chart_monthly_sales = new GoogleChart();
            $chart_monthly_sales->setChartAttrs( array(
                'type' => 'bvs',
                'title' => 'Sales History For The Year ' . $year,
                'data' => $data_sales,
                'size' => array( 725, 200 ),
                'color' => $color,
                'axisXY' => true,
                //'legend'    =>  array('Sales|Figures'),
                //'labelsXY' => '1:|' . $labelsY,
                ));

            
            // Load the template
            //$this->template->set('chart_top_products', $chart_top_products);

            $get_version = smp_version_check(true);
            $app_version = smp_lookup('key_value', $this->config->item('tbl_config'), 'key_name = \'VERSION\'');

            if($get_version > $app_version){
                $version_message = "<b>NEW VERSION AVAILABLE</b><br><br>
                                    SMP Version ". $get_version ." is available now. You are using ". $app_version .". <a href=http://www.sitemanpro.com/login target=_New>Click here</a> to download the latest version now.";
                $this->template->set('sb_sticky', $version_message);
            }
            else {
                $version_message = "Get up to speed on website development, setting up membership site, article writing, getting traffic & everything else in between that you need to succeed at making fast & easy money online - <a href=http://www.sitemanpro.com/classroom/membership/ target=_New><b>Join SMP Classroom</a></b>";
                $this->template->set('sb_sticky', $version_message);
            }

            $total_sales = smp_lookup('SUM(transaction_amount)', $this->config->item('tbl_transactions'), 'transaction_status_details = \'completed\'');
            $total_refunds = smp_lookup('SUM(transaction_amount)', $this->config->item('tbl_transactions'), 'transaction_status_details = \'refunded\'');
            $sales_count = smp_lookup('count(transaction_id)', $this->config->item('tbl_transactions'), 'transaction_status_details = \'completed\'');
            $customer_count = smp_lookup('count(user_id)', $this->config->item('tbl_users'), 'role_id = 2');
            $admin_count = smp_lookup('count(user_id)', $this->config->item('tbl_users'), 'role_id = 1');

            if(!$total_refunds){
                $total_refunds = 0.00;
            }
            $fun_facts = "Orders Processed: ". $sales_count ."<br>
                          Revenue: $". $total_sales ."<br>
                          Refunds: $". $total_refunds ."<br><br>
                          Total Customers: ". $customer_count ."<br>
                          Total Admins: ". $admin_count ."<br>";


            /* ---------------------- */
            /* LOAD THE TUTORIAL FEED */
            /* ---------------------- */
            /*
            $link = $this->config->item('smp_tutorials_feed');
            $data['feed'] = new SimplePie();
            $data['feed']->set_feed_url($link);
            $data['feed']->enable_cache(false);
            $data['feed']->init();
            $data['feed']->handle_content_type();
            $items = $data['feed']->get_items();
            $icount = 0;
            foreach($items as $item){
                $icount++;
                $quick_guides .=  "<a href='". $item->get_permalink() ."' target='_New'>" . $item->get_title() . "</a><br><br>";
                if($icount >=6)
                    break;
             }
             $quick_guides .=  "<a href='". $this->config->item('smp_tutorials') ."' target='_New'>>> Click here for more tutorials</a>";

            $this->template->set('sb_box_title_2', 'Helpful Guides');
            $this->template->set('sb_box_2', $quick_guides);
             * 
             */
            /* ---------------------- */

            /* ---------------------- */
            /*  LOAD THE FORUM FEED   */
            /* ---------------------- */
            /*
            $link = $this->config->item('smp_forum_feed');
            $data['feed'] = new SimplePie();
            $data['feed']->set_feed_url($link);
            $data['feed']->enable_cache(false);
            $data['feed']->init();
            $data['feed']->handle_content_type();
            $items = $data['feed']->get_items();
            foreach($items as $item){
                 $forum_feed .=  "<a href='". $item->get_permalink() ."' target='_New'><b>" . $item->get_title() . "</b></a> - ". substr(str_replace('<br />', '', $item->get_description()), 0, 100) ."... <i><a href='". $item->get_permalink() ."' target='_New'>read more</a></i><br><br>";
             }

            $this->template->set('forum_feed', $forum_feed);
            */
            /* ---------------------- */

            /* ---------------------- */
            /*  LOAD THE ADMIN FEED   */
            /* ---------------------- */
            /*
            $link = $this->config->item('smp_admin_feed');
            $data['feed'] = new SimplePie();
            $data['feed']->set_feed_url($link);
            $data['feed']->enable_cache(false);
            $data['feed']->init();
            $data['feed']->handle_content_type();
            $items = $data['feed']->get_items();
            foreach($items as $item){
                 $admin_feed .=  "<a href='". $item->get_permalink() ."' target='_New'><b>" . $item->get_title() . "</b></a> - ". substr(str_replace('<br />', '', $item->get_description()), 0, 100) ."... <i><a href='". $item->get_permalink() ."' target='_New'>read more</a></i><br><br>";
             }

            $this->template->set('admin_feed', $admin_feed);
            */
            /* ---------------------- */

            $this->template->set('total_sales', $total_sales);
            $this->template->set('chart_monthly_sales', $chart_monthly_sales);
            
            $this->template->set('sb_box_title_1', 'Quick System Stats');
            $this->template->set('sb_box_1', $fun_facts);

            $this->template->view($this->config->item('dashboard_view'));

	}
}

/* End of file dashboard.php */
/* Location: ./app/controllers/global/dashboard.php */