<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Dashboard_model extends Model {

    function Dashboard_model()
    {
            parent::Model();
    }

    //---------------------------------------------------------------

    /**
     * Function: monthly_sales
     * Description: Get the monthly sales for the year passed
     * ##############################################################
     * Written: 03/07/2011
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return void
     */
    function monthly_sales($year = '')
    {
        if(!$year)
            $year = date("Y");


        $this->db->select('SUM(transaction_amount) AS sales, MONTH(transaction_date) AS month');
        $this->db->from('global_transactions');
        $where_condition = "YEAR(transaction_date) = '$year' AND transaction_status_details = 'completed'";
        $this->db->where($where_condition);
        $this->db->group_by("MONTH(transaction_date)");
        $query = $this->db->get();


        $sales_jan=0.00;
        $sales_feb=0.00;
        $sales_mar=0.00;
        $sales_apr=0.00;
        $sales_may=0.00;
        $sales_jun=0.00;
        $sales_jul=0.00;
        $sales_aug=0.00;
        $sales_sep=0.00;
        $sales_oct=0.00;
        $sales_nov=0.00;
        $sales_dec=0.00;

        $where_condition = "YEAR(transaction_date) = '$year'";
        $sales_max = smp_lookup('MAX(transaction_amount)', 'global_transactions', $where_condition);


        foreach ($query->result() as $row){
            switch ($row->month) {
                case "1":
                    $sales_jan = $row->sales;
                break;
                case "2":
                    $sales_feb = $row->sales;
                break;
                case "3":
                    $sales_mar = $row->sales;
                break;
                case "4":
                    $sales_apr = $row->sales;
                break;
                case "5":
                    $sales_may = $row->sales;
                break;
                case "6":
                    $sales_jun = $row->sales;
                break;
                case "7":
                    $sales_jul = $row->sales;
                break;
                case "8":
                    $sales_aug = $row->sales;
                break;
                case "9":
                    $sales_sep = $row->sales;
                break;
                case "10":
                    $sales_oct = $row->sales;
                break;
                case "11":
                    $sales_nov = $row->sales;
                break;
                case "12":
                    $sales_dec = $row->sales;
                break;

            }
        }

        $data_sales = array(
            'Jan' => $sales_jan/1000,
            'Feb' => $sales_feb/1000,
            'Mar' => $sales_mar/1000,
            'Apr' => $sales_apr/1000,
            'May' => $sales_may/1000,
            'Jun' => $sales_jun/1000,
            'Jul' => $sales_jul/1000,
            'Aug' => $sales_aug/1000,
            'Sep' => $sales_sep/1000,
            'Oct' => $sales_oct/1000,
            'Nov' => $sales_nov/1000,
            'Dec' => $sales_dec/1000
        );

        //print_r($data_sales);

        return $data_sales;        
    }


    //---------------------------------------------------------------

    /**
     * Function: best_sellers
     * Description: Get the best sellers
     * ##############################################################
     * Written: 03/07/2011
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return void
     */
    function best_sellers($limit = '5')
    {

        $this->db->select('transaction_title');
        $this->db->from('global_transactions');
        $this->db->where('transaction_status_details', 'completed');
        $this->db->group_by("transaction_title");
        $this->db->order_by("transaction_amount", "desc");
        $this->db->limit($limit);
        $query = $this->db->get();


        foreach ($query->result() as $row){
            $best_sellers[] = $row->transaction_title;
        }

        print_r($best_sellers);

        return $best_sellers;
    }


}

?>
