<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Smp_model extends Model {

    function Smp_model()
    {
            parent::Model();
    }

    //---------------------------------------------------------------

    /**
     * Function: process_form
     * Description: Get form rules
     * ##############################################################
     * Written: 01/26/2010
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return void
     */
    function process_form($field_array, $table_name, $table_action, $where_additional = '') {
        if ($this->db->table_exists($table_name)):
            switch($table_action) {
                case "Save":
                    if ($where_additional){
                        $this->db->where($where_additional);
                        $field_array['r_mod_id'] = $this->session->userdata('user_id');
                        $field_array['r_mod_time'] = smp_datetime();
                        $this->db->update($table_name, $field_array);
                        $this->template->set('system_message',  $this->lang->line('message_record_updated'));
                        return 1;
                    }
                    else{
                        $this->template->set('system_message',  $this->lang->line('message_nowhere'));
                        return 0;
                    }
                break;
                case "Submit":
                    $field_array['r_cre_id'] = $this->session->userdata('user_id');
                    $field_array['r_cre_time'] = smp_datetime();
                    $field_array['r_mod_id'] = $this->session->userdata('user_id');
                    $field_array['r_mod_time'] = smp_datetime();
                    $this->db->insert($table_name, $field_array);
                    $this->template->set('system_message',  $this->lang->line('message_record_inserted'));
                    return 1;
                break;
                case "Delete":
                    if ($where_additional){
                        //$this->db->where($where_additional);
                        $this->db->delete($table_name, $where_additional);
                        $this->template->set('system_message',  $this->lang->line('message_record_deleted'));
                        return 1;
                    }
                    else{
                        $this->template->set('system_message',  $this->lang->line('message_nowhere'));
                        return 0;
                    }

                break;
                case "default":
                break;
            }
            //echo $this->db->last_query();
        endif;
	
    }
    //---------------------------------------------------------------

    /**
     * Function: look_up
     * Description: Get the field value from table
     * ##############################################################
     * Written: 03/11/2010
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return void
     */
    function look_up($field_name, $table_name, $where_condition)
    {
        $this->db->select($field_name);
        $this->db->from($table_name);
        if ($where_condition) {
            $this->db->where($where_condition);
        }
        $this->db->limit(1);

        $query = $this->db->get();

        if ($query->num_rows() > 0)
        {
            foreach ($query->result() as $row){
                return $row->$field_name;
            }
        }
        return 0;
    }
    //---------------------------------------------------------------

    /**
     * Function: fetch_records
     * Description: Fetch the table records
     * ##############################################################
     * Written: 04/12/2010
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return total count of links
     */
    function get_records($table_name, $where_additional = '', $offset = 0, $limit = 25)
    {
        $this->db->select('*');
        if ($where_additional){
                $this->db->where($where_additional);
        }
        $this->db->limit($limit, $offset);
        $query = $this->db->get($table_name);
        return $query->result();
    }

    //---------------------------------------------------------------

    /**
     * Function: fetch_records
     * Description: Fetch the table records
     * ##############################################################
     * Written: 04/12/2010
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return total count of links
     */
    function get_options($table_name, $field_key, $field_value, $where_additional = '', $default_value_none = true)
    {
        $fields = $field_key . "," . $field_value;
        $this->db->select($fields);
        if ($where_additional){
                $this->db->where($where_additional);
        }
        $query = $this->db->get($table_name);
        if ($default_value_none){
            $options[''] = 'Select Value';
        }
        if ($query->num_rows() > 0)
        {
            foreach ($query->result() as $row)
            {
                $options[ $row->$field_key ] = $row->$field_value;
            }
            return $options;
        }
        return $options;
        //return $query->result_array() ;
    }

    /**
     * Function: count_records
     * Description: Fetch the total count of records
     * ##############################################################
     * Written: 03/11/2010
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return total count of links
     */
    function count_records($table_name, $where_additional='')
    {
        if ($where_additional){
                $this->db->where($where_additional);
        }
        return $this->db->count_all_results($table_name);
    }

    /**
     * Function: process_table
     * Description: Process an action on table
     * ##############################################################
     * Written: 05/06/2010
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return void
     */
    function process_table($field_array, $table_name, $table_action, $where_additional = '') {
        if ($this->db->table_exists($table_name)):
            switch($table_action) {
                case "Save":
                    if ($where_additional){
                        $this->db->where($where_additional);
                        $field_array['r_mod_id'] = $this->session->userdata('user_id');
                        $field_array['r_mod_time'] = smp_datetime();
                        $this->db->update($table_name, $field_array);
                        $this->template->set('system_message',  $this->lang->line('message_record_updated'));
                        return 1;
                    }
                    else{
                        $this->template->set('system_message',  $this->lang->line('message_nowhere'));
                        return 0;
                    }
                break;
                case "Submit":
                    $field_array['r_cre_id'] = $this->session->userdata('user_id');
                    $field_array['r_cre_time'] = smp_datetime();
                    $field_array['r_mod_id'] = $this->session->userdata('user_id');
                    $field_array['r_mod_time'] = smp_datetime();
                    $this->db->insert($table_name, $field_array);
                    $this->template->set('system_message',  $this->lang->line('message_record_inserted'));
                    return 1;
                break;
                case "Delete":
                    if ($where_additional){
                        //$this->db->where($where_additional);
                        $this->db->delete($table_name, $where_additional);
                        $this->template->set('system_message',  $this->lang->line('message_record_deleted'));
                        return 1;
                    }
                    else{
                        $this->template->set('system_message',  $this->lang->line('message_nowhere'));
                        return 0;
                    }

                break;
                case "default":
                break;
            }
            //echo $this->db->last_query();
        endif;

    }
    //---------------------------------------------------------------

    //TODO: Make it fully generic function. Remove all table specific coloums.

    function get_cat_tree($table_name, $child_field, $parent_field, $title_field, $link_field = '', $link_path = '', $where_additional = '')
    {
        $category_tree = "";
        if ($this->db->table_exists($table_name)):
            $this->db->select('*');

            if ($where_additional){
                    $this->db->where($where_additional);
            }

            $where_additional = "(category_parent is NULL OR category_parent = 0)";
            $this->db->where($where_additional);
        
            $query = $this->db->get($table_name);

            if ($query->num_rows() > 0)
            {
                $category_tree .= "<ul id='cat-menu' class='cat-menu'>";
                foreach ($query->result() as $row)
                {
                    $category_tree .= "<li id='cat-menu' class='cat-menu'>1.<a href='" . $link_path . "/". $row->$link_field ."'>" . $row->category_name . "</a></li>";
                    $category_tree .= $this->_get_cat_tree_1($row->$child_field, "0", $link_field, $link_path);
                }
                $category_tree .= "</ul>";
            }
            return $category_tree;
        endif;
    }

    function _get_cat_tree_1($category_id, $callbackpart2 = '0', $link_field = '', $link_path = '')
    {
        $category_tree = "";
        if ($callbackpart2 == "1")
        {
            $this->_get_cat_tree_2($category_id);
        }
        $this->db->select('*');
        $this->db->where('category_parent', $category_id);
        $query = $this->db->get('post_categories');

        if ($query->num_rows() > 0)
        {
            $category_tree .= "<ul id='cat-menu' class='cat-menu'>";
            foreach ($query->result() as $row)
            {
                $category_tree .= "<li id='cat-menu' class='cat-menu'>2.<a href='". $link_path . "/" . $row->$link_field ."'>" . $row->category_name . "</a></li>";
                if ($row->category_parent > 0 && $row->category_parent <> "")
                {
                        $category_tree .= $this->_get_cat_tree_2($row->category_id, $link_field, $link_path);
                }
            }
            $category_tree .= "</ul>";
        }
        return $category_tree;
    }


    function _get_cat_tree_2($category_id, $link_field = '', $link_path = '')
    {
        $category_tree = "";
        $this->db->select('*');
        $this->db->where('category_parent', $category_id);
        $query = $this->db->get('post_categories');
        
        $callbacktrue = "0";
        if ($query->num_rows() > 0)
        {
            $category_tree .= "<ul id='cat-menu' class='cat-menucat'>";
            foreach ($query->result() as $row)
            {
                $category_tree .= "<li id='cat-menu' class='cat-menu'>3.<a href='". $link_path . "/" . $row->$link_field ."'>" . $row->category_name . "</a></li>";
                if ($row->category_parent > 0 && $row->category_parent <> "")
                {
                    $callbackpart2 = "1";
                    $category_tree .= $this->_get_cat_tree_1($row->category_id, $callbackpart2);
                }
            }
            $category_tree .= "</ul>";

        }
        return $category_tree;
    }

    function get_category_tree($parent_id = 0, $escape = 0, $spacing = '', $tree = '', $where = '') {
        if (!is_array($tree))
                $tree = array();

        $filter = '';
        if($where != '')
                $filter = " AND " . $where;

        /*if($escape == 0) {
                if (sizeof($tree) < 1)
                        $tree[] = array('id' => '0', 'name' => 'Top');
        }*/

        $sql = "SELECT * FROM post_categories WHERE category_parent  = '" . $parent_id ."' ".$filter." ORDER BY category_id ";
        $result = $this->db->query($sql);

        foreach($result->result() as $row)
        {
            $tree[] = array(
                'id' => $row->category_id,
                'name' => $spacing . $row->category_name
            );
            $tree = $this->get_category_tree($row->category_id, $escape, $spacing . '&nbsp;&nbsp;&nbsp;', $tree, $where);
        }

        return $tree;
    }

    //---------------------------------------------------------------

    /**
     * Function: get_pending_subscriptions
     * Description: Fetch the pending subscriptions
     * ##############################################################
     * Written: 12/03/2010
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return total count of links
     */
    function get_pending_subscriptions($limit = 50)
    {
        $bill_attempts = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'BILL_ATTEMPTS'");
        $this->db->select('u.user_id, u.username, u.first_name, u.last_name, u.addr_street, u.addr_city, u.addr_state, u.addr_zip, u.addr_country, u.card_num, u.email, u.card_code, u.exp_mon, u.exp_yr, t.transaction_id, t.transaction_amount, t.next_bill_date, t.next_billed_flg, o.order_id, o.product_id, p.product_name, g.gateway_id, g.title, g.setting_1, g.setting_2, g.setting_3, g.setting_4, g.setting_5, g.setting_6, g.setting_7, g.setting_8, g.setting_9, g.setting_10, g.controller');
        $this->db->from('global_transactions t');
        $this->db->join('global_users u', 't.user_id = u.user_id');
        $this->db->join('shop_order_items o', 't.transaction_id = o.order_id');
        $this->db->join('shop_products p', 'o.product_id = p.product_id');
        $this->db->join('global_gateways g', 't.channel_id = g.gateway_id');
        $where = "(t.next_billed_flg = 'N' OR t.next_billed_flg = 'F')";
        $this->db->where($where);
        $this->db->where('t.next_bill_date <=', smp_datetime());
        
        if ($bill_attempts > 0){
            $this->db->where('t.bill_attempts <=', $bill_attempts);
        }
        $this->db->limit($limit);
        $query = $this->db->get();

        return $query->result();
    }

    //---------------------------------------------------------------

    /**
     * Function: execute_sql
     * Description: Execute the SQL statement
     * ##############################################################
     * Written: 01/04/2011
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return void
     */
    function execute_sql($sql = '')
    {
        if($sql){
            $this->db->query($sql);
        }
        return true;
    }

    function log_action($log_message, $log_type = '', $log_by = '')
    {
        $field_array['log_message'] = $log_message;
        $field_array['log_time'] = smp_datetime();
        $field_array['log_by'] = $log_by;
        $field_array['log_type'] = $log_type;
        $field_array['log_ip'] = $_SERVER['REMOTE_ADDR'];
        $this->db->insert($this->config->item('tbl_logs'), $field_array);
        return true;
    }


    /**
     * Function: get_hooks
     * Description: Fetch the pending subscriptions
     * ##############################################################
     * Written: 12/03/2010
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return total count of links
     */
    function get_hooks($hook)
    {
        $this->db->select('*');
        $this->db->from($this->config->item('tbl_hooks'));
        $this->db->where('action_hook', $hook);
        $this->db->where('flg_enable', 'Y');
        $query = $this->db->get();

        return $query->result();
    }
}

?>
