<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Myorders extends Controller {

    function __construct() {
            parent::Controller();
            $module_name = "shop";
            $this->load->model($this->config->item('shop_model'));
            $this->load->model($this->config->item('smp_model'));
            $this->lang->load('shop', 'english');
    }

    //---------------------------------------------------------------

    //<editor-fold desc="FUNCTION DESCRIPTION: SHOW THE PURCHASES LIST PAGE">
    /*
     * Function: index
     * Description: Shows the purchases list page
     * ##############################################################
     * Written: 10/11/2010
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return void
     */
    //</editor-fold>
    function index($offset = '')
    {
        //<editor-fold desc="CHECK USER PERMISSION">
        smp_check_permission($this->config->item('perm_view'));
        //</editor-fold>

        //<editor-fold desc="SET PAGE META">
        smp_set_page_meta('shop', 'myorders');
        //</editor-fold>
        //
        //<editor-fold desc="FETCHING DATA">
        $where_additional = "user_id = " . $this->session->userdata('user_id');
        $total_records = smp_count($this->config->item('tbl_transactions'), $where_additional);
        $where_additional = "transaction_status_details NOT IN ('refunded', 'pending') AND user_id = " . $this->session->userdata('user_id');
        $result_set['orders'] = $this->Shop_model->get_orders($offset, $this->config->item('records_per_page'), $where_additional);
        $pagination = smp_set_pagination($this->config->item('page_list_myorders'), $total_records);

        $this->Shop_model->set_promo();
        //</editor-fold>

        //<editor-fold desc="LOAD THE TEMPLATE">
        $this->template->set('resultset', $result_set['orders']);
        $this->template->set('pagination', $pagination);
        $this->template->view($this->config->item('myorder_list_view'));
        //</editor-fold>
    }


}

/* End of file myorders.php */
/* Location: ./app/controllers/shop/myorders.php */