<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Shop extends Controller {

    function __construct() {
            parent::Controller();
            $this->load->model($this->config->item('shop_model'));
            $this->load->model($this->config->item('smp_model'));
    }

    //---------------------------------------------------------------

    //<editor-fold desc="FUNCTION DESCRIPTION: SHOW THE ORDER PAGE">
    /*
     * Function: index
     * Description: Shows the order page
     * ##############################################################
     * Written: 10/06/2010
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return void
     */
    //</editor-fold>
    function getP($product_id = '')
    {
        $product_id = smp_decode($product_id);

        $flg_enabled = smp_lookup('flg_enabled', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
        if($flg_enabled == "No"){
            $info_url = smp_lookup('info_url', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
            echo "<body bgcolor='#fafafa'><center><br><br><br><a href='" . $info_url . "'><img src='". $this->config->item('base_url') ."/assets/images/soldout.png' border='0'></a></center></body>";
            exit;
        }

        if ((!smp_check_session()) || ($this->input->post('action') == 'login')){
            $this->session->unset_userdata('user_id');
            if ($this->input->post('submitform') && $this->input->post('product_id')){
                if ($this->input->post('action') == 'login'){
                    $this->form_validation->set_rules('email', 'Email', 'trim|required|xss_clean');
                    if ($this->form_validation->run() == FALSE)
                    {
                        $this->_show_user_form($product_id, 'login', '', 'Please enter your email');
                    }
                    else{
                        $user_id = smp_lookup('user_id', $this->config->item('tbl_users'), 'email = \'' . $this->input->post('email') . '\'');
                        if ($user_id > 0){
                            $user_data = array
                            (
                                'user_id' => $user_id
                            );
                            $this->session->set_userdata($user_data);
                            $this->_show_order_form($product_id);
                        }
                        else{
                            $this->_show_user_form($product_id, 'register', $this->input->post('email'));
                        }
                    }
                }
                if ($this->input->post('action') == 'register'){

                    $this->form_validation->set_rules('first_name', 'First Name', 'trim|required|xss_clean');
                    $this->form_validation->set_rules('last_name', 'Last Name', 'trim|required|xss_clean');
                    $this->form_validation->set_rules('email', 'Email', 'trim|required|xss_clean');
                    $this->form_validation->set_rules('password', 'Password', 'trim|required|xss_clean');

                    if ($this->form_validation->run() == FALSE)
                    {
                        $this->_show_user_form($product_id, 'register', $this->input->post('email'), 'Please enter all fields');
                    }
                    else{
                        // Create new user account
                        $field_array['first_name'] = $this->input->post('first_name');
                        $field_array['last_name'] = $this->input->post('last_name');
                        $field_array['email'] = $this->input->post('email');
                        $field_array['username'] = $this->input->post('email');
                        $field_array['password'] = $this->input->post('password');
                        $field_array['role_id'] = 2;
                        $field_array['r_cre_time'] = smp_datetime();
                        $field_array['r_mod_time'] = smp_datetime();
                        $field_array['remote_addr'] = smp_getIp();
                        $field_array['last_ip'] = smp_getIp();
                        $this->db->insert($this->config->item('tbl_users'), $field_array);
                        $user_id = $this->db->insert_id();
                        $user_data = array
                        (
                            'user_id' => $user_id
                        );
                        $this->session->set_userdata($user_data);
                        $this->_show_order_form($product_id);
                        //echo $this->session->userdata('user_id');
                    }
                }
            }
            else {
                $this->_show_user_form($product_id, 'login');
            }



        }
        else {
            if ($this->input->post('submitform') && $this->input->post('product_id')){
                if ($this->input->post('is_free') == 'true'){
                    $gateway_controller = "gateways/free/process/" . $this->input->post('product_id');
                    $gateway_controller = site_url($gateway_controller);
                    header('Location: ' . $gateway_controller);
                }
                elseif ($this->input->post('gateway')){
                    $gateway_file = smp_lookup('controller', $this->config->item('tbl_gateways'), 'gateway_id = ' . $this->input->post('gateway'));
                    if($gateway_file == "points"){
                        $require_points = smp_lookup('require_points', $this->config->item('tbl_products'), 'product_id = ' . $this->input->post('product_id'));
                        $points_balance = smp_lookUp("points_balance", $this->config->item('tbl_users'), "user_id = " . $this->session->userdata('user_id'));

                        if ($points_balance < $require_points){
                            $error_msg = "Sorry, you have only " . $points_balance . " points. This product requires " . $require_points . " points. <br>Please use another payment method to place your order.";
                            $this->_show_order_form($product_id, $error_msg);
                            exit;
                        }

                    }

                    $gateway_controller = "gateways/" . $gateway_file . "/process/" . $this->input->post('product_id') . "/" . $this->input->post('gateway');
                    $gateway_controller = site_url($gateway_controller);
                    header('Location: ' . $gateway_controller);
                }
                else {
                    $error_msg = "Please select a payment method";
                    $this->_show_order_form($product_id, $error_msg);
                }
            }
            else {
                if ($product_id){
                    if(smp_lookup('product_id', $this->config->item('tbl_products'), 'product_id = ' . $product_id)){
                        $this->_show_order_form($product_id);
                    }
                    else{
                        echo $this->lang->line('message_invalid_product');
                    }
                }
                else{
                    echo $this->lang->line('message_invalid_product');
                }
            }
        }
    }

    function _show_order_form($product_id, $error_msg = ''){
        $template_id = smp_lookup('template_id', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
        $template_code = smp_lookup('template_code', $this->config->item('tbl_templates'), 'template_id = ' . $template_id);

        $image = "<img src=" . smp_lookup('image_url', $this->config->item('tbl_products'), 'product_id = ' . $product_id) . ">";
        $product_name = smp_lookup('product_name', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
        $currency_code = smp_lookup('currency_code', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
        $price = smp_lookup('price', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
        $description = smp_lookup('description', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
        $product_license = smp_lookup('product_license', $this->config->item('tbl_products'), 'product_id = ' . $product_id);

        $require_points = smp_lookup('require_points', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
        $points_balance = smp_lookUp("points_balance", $this->config->item('tbl_users'), "user_id = " . $this->session->userdata('user_id'));

        if ($require_points > 0){
            $require_points = " (or " . $require_points . " points)";
        }
        else{
            $require_points = "";
        }


        if (! smp_lookup('image_url', $this->config->item('tbl_products'), 'product_id = ' . $product_id)){
            $image ="";
        }
        
        $template_code = str_replace("{tag_downloadinfo}", '', $template_code);
        $template_code = str_replace("{tag_productimage}", $image, $template_code);
        $template_code = str_replace("{tag_productname}", $product_name, $template_code);
        $template_code = str_replace("{tag_productprice}", $currency_code . "&nbsp;" . $price . $require_points, $template_code);
        $template_code = str_replace("{tag_productdescription}", $description, $template_code);
        $template_code = str_replace("{tag_productlicense}", $product_license, $template_code);
        $options = get_options($this->config->item('tbl_product_gateways'), 'gateway_id', 'gateway_title', $where_condition = 'product_id = ' . $product_id);
        $payment_form = "<h3>Payment Information</h3><form action='' method='post'>";
        if ($error_msg) { $payment_form .= "<font style='color:#ff0000; font-weight: bold; font-family: arial; font-size: 10px;'>$error_msg</font><br>"; }
        $payment_form .= "<input type='hidden' name='product_id' value='$product_id'>";
        $payment_form .= "<input type='hidden' name='submitform' value='true'>";
        if($price > 0){
            $payment_form .= "Pay through: " . form_dropdown('gateway', $options, '', '');
            $payment_form .= "<input type='hidden' name='is_free' value='false'>";
            $payment_form .= "<br><br><input type='image' name='submit' id='submit' src='". base_url() ."/assets/images/btnbuynow.png'>";
        }
        else{
            $payment_form .= $this->lang->line('label_free_access');
            $payment_form .= "<input type='hidden' name='is_free' value='true'>";
            $payment_form .= "<br><br><input type='image' name='submit' id='submit' src='". base_url() ."/assets/images/btncontinue.png'>";
        }
        $payment_form .= "</form>";
        $template_code = str_replace("{tag_paymentform}", $payment_form, $template_code);
        /* ################################################ */
        /* YOU CANNOT REMOVE THIS POWERED BY NOTICE */
        $affiliate_id = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'CB_ACCOUNT'");
        if($affiliate_id){
            $template_code .= "<center><a href='http://$affiliate_id.sitemanpro.hop.clickbank.net' target='_New' style = 'font-size:8px; font-family: arial; color: #999999; text-decoration: none'>Powered by SiteManPro</a></center>";
        }
        else{
            $template_code .= "<center><a href='http://sitemanpro.com' target='_New' style = 'font-size:8px; font-family: arial; color: #999999; text-decoration: none'>Powered by SiteManPro</a></center>";
        }

        /* ################################################ */

        echo $template_code;
    }

    function _show_user_form($product_id, $mode = 'login', $data = '' , $error_msg = ''){
        $template_id = smp_lookup('template_id', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
        $template_code = smp_lookup('template_code', $this->config->item('tbl_templates'), 'template_id = ' . $template_id);

        $image = "<img src=" . smp_lookup('image_url', $this->config->item('tbl_products'), 'product_id = ' . $product_id) . ">";
        $product_name = smp_lookup('product_name', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
        $price = smp_lookup('price', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
        $description = smp_lookup('description', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
        $product_license = smp_lookup('product_license', $this->config->item('tbl_products'), 'product_id = ' . $product_id);

        if (! smp_lookup('image_url', $this->config->item('tbl_products'), 'product_id = ' . $product_id)){
            $image ="";
        }
        
        $template_code = str_replace("{tag_downloadinfo}", '', $template_code);
        $template_code = str_replace("{tag_productimage}", $image, $template_code);
        $template_code = str_replace("{tag_productname}", $product_name, $template_code);
        $template_code = str_replace("{tag_productprice}", $price, $template_code);
        $template_code = str_replace("{tag_productdescription}", $description, $template_code);
        $template_code = str_replace("{tag_productlicense}", $product_license, $template_code);

        switch($mode)
        {
                case "login":
                    $payment_form = "<h3>Enter Your Email Address</h3>If you are a returning customer, your info will be restored..<br>";
                    $payment_form .= "<form action='' method='post'>";
                    if ($error_msg) { $payment_form .= "<font style='color:#ff0000; font-weight: bold; font-family: arial; font-size: 10px;'>$error_msg</font><br>"; }
                    $payment_form .= "<br>Email: <input type='text' name='email' value=''>";
                    $payment_form .= "<input type='hidden' name='product_id' value='$product_id'>";
                    $payment_form .= "<input type='hidden' name='submitform' value='true'>";
                    $payment_form .= "<input type='hidden' name='action' value='login'>";
                    $payment_form .= "<br><br><input type='image' name='submit' id='submit' src='". base_url() ."/assets/images/btncontinue.png'>";
                    $payment_form .= "</form>";
                break;

                case "register":
                    $payment_form = "<h3>Please Enter Your Details To Continue..</h3>";
                    $payment_form .= "<form action='' method='post'>";
                    if ($error_msg) { $payment_form .= "<font style='color:#ff0000; font-weight: bold; font-family: arial; font-size: 10px;'>$error_msg</font><br>"; }
                    $payment_form .= "<table>";
                    $payment_form .= "<tr><td>Your Email: </td><td>". $data ."<input type='hidden' name='email' value='". $data ."'></td></tr>";
                    $payment_form .= "<tr><td>First Name: </td><td><input type='text' name='first_name' value=''></td></tr>";
                    $payment_form .= "<tr><td>Last Name: </td><td><input type='text' name='last_name' value=''></td></tr>";
                    $payment_form .= "<tr><td>Password: </td><td><input type='password' name='password' value=''></td></tr>";
                    $payment_form .= "<input type='hidden' name='product_id' value='$product_id'>";
                    $payment_form .= "<input type='hidden' name='submitform' value='true'>";
                    $payment_form .= "<input type='hidden' name='action' value='register'>";
                    $payment_form .= "<tr><td colspan=2 align=right><input type='image' name='submit' id='submit' src='". base_url() ."/assets/images/btncontinue.png'></td></tr>";
                    $payment_form .= "</form>";
                    $payment_form .= "</table>";
                break;

                default:
                break;
        }

        $template_code = str_replace("{tag_paymentform}", $payment_form, $template_code);
        /* ################################################ */
        /* YOU CANNOT REMOVE THIS POWERED BY NOTICE */
        $affiliate_id = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'CB_ACCOUNT'");
        if($affiliate_id){
            $template_code .= "<center><a href='http://$affiliate_id.sitemanpro.hop.clickbank.net' target='_New' style = 'font-size:8px; font-family: arial; color: #999999; text-decoration: none'>Powered by SiteManPro</a></center>";
        }
        else{
            $template_code .= "<center><a href='http://sitemanpro.com' target='_New' style = 'font-size:8px; font-family: arial; color: #999999; text-decoration: none'>Powered by SiteManPro</a></center>";
        }
        /* ################################################ */

        echo $template_code;
    }
}

/* End of file shop.php */
/* Location: ./app/controllers/socket/shop.php */